﻿var Player = 
    { 
        plugin : null, 
        SefPlugin: null,
        originalSource : null,
        state : -1,
        size: 0,
        w: 0,
        h: 0,
        STOPPED : 0, 
        PLAYING : 1, 
        PAUSED : 2,
        time: 0,
        setup_time: 0,
        url: "",
        msg_0: "",
        msg_1: "",
        msg_2: "",
        msg_3: "",
        msg_4: "",
        msg_5: "",
        infoTimeout_id: 0,
        playTimeout_id: 0,
        sizeTimeout_id: 0,
        cntErr: 0
    }

Player.hideAlert=function()
{
    var al=document.getElementById("alert");
    if (al!=null) al.style.display="none";
}    

Player.init = function(lang)
{
   var success = true;
   this.state = this.STOPPED;

   //Подключаем СЕФ
   var NNaviPlugin = document.getElementById("pluginObjectNNavi");
   var firmware = NNaviPlugin.GetFirmware().split('-');
   if(firmware[1] && (firmware[1].indexOf('2011')!=-1 || 
                      firmware[1].indexOf('2012')!=-1 || 
                      firmware[1].indexOf('2013')!=-1))
   this.SefPlugin=document.getElementById("pluginObjectSef");

   if (this.SefPlugin == null){
      this.plugin = document.getElementById("pluginPlayer");
   }

   if (!this.plugin && !this.SefPlugin)
       success = false;
   else{
       var wPlugin = document.getElementById("pluginWindow");
       if (!wPlugin)
           success = false;
       else{
           if (typeof wPlugin.GetSource== "function"){
              this.originalSource =wPlugin.GetSource();
              wPlugin.SetSource(43);
           }
       }
   }

   if (this.plugin){
      this.plugin.OnCurrentPlayTime = 'Player.setCurTime';
      this.plugin.OnStreamInfoReady ='Player.onStreamInfoReady';  
      this.plugin.OnBufferingStart = 'Player.onBufferingStart';
      this.plugin.OnBufferingComplete = 'Player.onBufferingComplete';
      this.plugin.OnRenderingComplete='Player.onRenderingComplete';
      this.plugin.OnNetworkDisconnected='Player.onNetworkDisconnected';
      this.plugin.OnBufferingProgress = 'Player.onBufferingProgress';
      this.plugin.OnRenderError='Player.onRenderError'; // numer
      this.plugin.OnStreamNotFound = 'Player.onStreamNotFound';
   }
   
   switch (lang) 
   {
       case "7":
           //CZ
           Player.msg_0="Připojení k serveru bylo přerušeno !";
           Player.msg_1="Nepodporovaný kontejner !";
           Player.msg_2="Nepodporovaný video kodek !";
           Player.msg_3="Nepodporovaný audio kodek !";
           Player.msg_4="Nepodporované rozlišení videa !";
           Player.msg_5="Stream nenájdený !";
          break;
          
       case "12":
           //DE
           Player.msg_0="Verbindung zum Server fehlgeschlagen !";
           Player.msg_1="Nicht unterstuetztes Format !";
           Player.msg_2="Video codec nicht unterstuetzt !";
           Player.msg_3="Audio codec nicht unterstuetzt !";
           Player.msg_4="Aufloesung wird nicht unterstuetzt !";
           Player.msg_5="Datei nicht gefunden !";
          break;
          
       case "15":
           //IT
           Player.msg_0="La Connessione al server è stata interrotta !";
           Player.msg_1="Tipo di contenitore non supportato !";
           Player.msg_2="Codec video non supportato !";
           Player.msg_3="Codec audio non supportato !";
           Player.msg_4="Risoluzione video non supportata !";
           Player.msg_5="File non trovato !";
           break;
                      
       case "18":
           //PL
           Player.msg_0="Połączenie z serwerem zostało przerwane !";
           Player.msg_1="Nieobsługiwany format pliku !";
           Player.msg_2="Nieobsługiwany kodek wideo !";
           Player.msg_3="Nieobsługiwany kodek audio !";
           Player.msg_4="Nieobsługiwany format pliku !";
           Player.msg_5="Nie znaleziono pliku !";
           break;
       
       case "21":
           //RU
           Player.msg_0="Связь с сервером прервана !";
           Player.msg_1="Неподдерживаемый контейнер !";
           Player.msg_2="Неподдерживаемый видео кодек !";
           Player.msg_3="Неподдерживаемый аудио кодек !";
           Player.msg_4="Неподдерживаемое видео разрешение !";
           Player.msg_5="Файл отсутствует !";
           break;
           
       case "23":
           //SK
           Player.msg_0="Sieť sa odpojila počas streamovania!";
           Player.msg_1="Nepodporovaný kontajner !";
           Player.msg_2="Nepodporovaný video codec !";
           Player.msg_3="Nepodporovaný audio codec !";
           Player.msg_4="Nepodporovaný video rozlíšenie!";
           Player.msg_5="Stream nenájdený !"; 
           break;
                            
      case "24":
           //ES
           Player.msg_0="La conexiГіn al servidor fue interrumpida !";
           Player.msg_1="Contenedor no apoyado !";
           Player.msg_2="CГіdec de vГ­deo no apoyado !";
           Player.msg_3="CГіdec de audio no apoyado !";
           Player.msg_4="ResoluciГіn de vГ­deo no apoyada !";
           Player.msg_5="Archivo no encontrado !"; 
           break;
           
       case "26":
           //TR
           Player.msg_0="Sunucu Bağlantısı kesildi!";
           Player.msg_1="Desteklenmeyen İçerik";
           Player.msg_2="Desteklenmeyen video codeci";
           Player.msg_3="Desteklenmeyen ses codeci";
           Player.msg_4="Desteklenmeyen video çözünürlüğü";
           Player.msg_5="Dosya bulunamadı!"; 
           break;
          
       default:
           Player.msg_0="Connection to server was interrupted !";
           Player.msg_1="Unsupported container !";
           Player.msg_2="Unsupported video codec !";
           Player.msg_3="Unsupported audio codec !";
           Player.msg_4="Unsupported video resolution !";
           Player.msg_5="File not found !";
           break;
   } 
   //var ret= this.plugin.SetPlayerProperty(3, "User-Agent:", "Mozilla/5.0 (Windows; U; Win 9x 4.90; en-US; rv:1.8.1.12) Gecko/20080201 Firefox/2.0.0.12");
   //alert('SetPlayerProperty='+ret);
   return success;
}

Player.setCurTime = function(time){
   Display.setTime(time);
   this.time=time;
}

Player.onStreamInfoReady=function()
{
   alert("onStreamInfoReady");
   if (this.state == this.PLAYING){
      Mode="PLAYER"; //чтоб не залипал выход
      if (this.plugin){
         Display.setTotalTime(this.plugin.GetDuration());
         this.h=this.plugin.GetVideoHeight();
         this.w=this.plugin.GetVideoWidth();
      }else if (this.SefPlugin){
         Display.setTotalTime(this.SefPlugin.Execute('GetDuration'));
         var vRes = this.SefPlugin.Execute('GetVideoResolution').toString();
         if (DelSpaces(vRes) != '' && vRes.indexOf('|') >= 0) {
             vRes = vRes.split('|');
             this.w = vRes[0];
             this.h = vRes[1];
         }else{
             this.w = 0;
             this.h = 0;
         }
      }
      this.setSize(this.size);
   }
}

Player.onBufferingStart = function() 
{
    alert("onBufferingStart");

    if (this.state != this.STOPPED){    
       Mode="PLAYER"; //чтоб не залипал выход
       document.getElementById("back_rss").style.display="none";
       Display.show();
       if (this.setup_time)
           Helpbar.make(6);
       else
           Helpbar.make(4);

       Loading.setPercent(-1);
       Loading.show();
    }
}

Player.onBufferingProgress = function(percent)
{
    alert("onBufferingProgress="+percent+"%");
    if (this.state != this.STOPPED){
       Mode="PLAYER"; //чтоб не залипал выход
       Loading.setPercent(percent);
       //Loading.show();
    }
}

Player.onBufferingComplete = function() 
{
   alert("onBufferingComplete");
   if (this.state != this.STOPPED){
      Mode="PLAYER"; //чтоб не залипал выход
      Loading.hide();
      this.infoTimeout_id = setTimeout("Display.hide();", 3000);
      //проверка наличия аудиодорожек
      setTimeout("AudioTrack.CheckExtAudioTrack();", 3000);
   }
}   


Player.onRenderingComplete=function()
{
   alert("onRenderingComplete");
   if (this.state != this.STOPPED){
      Player.duration=0;
      Player.stopVideo();
   }
}

Player.onNetworkDisconnected=function() 
{
    alert("onNetworkDisconnected");
    Player.error(0);
    /*
    if (this.plugin){
       this.plugin.ResumePlay(this.url,this.time);
    }else if (this.SefPlugin){
       this.SEFPlay(this.url,this.time);
    }
    */
}
 
Player.onStreamNotFound=function() {
   alert("onStreamNotFound");
   Player.error(5);
}

Player.onRenderError=function(err){ 
   alert("onRenderError="+err);
   Player.error(err);
}

Player.error=function(err)
{
   alert("Player.error:" + err);
   Loading.hide();

   if (this.state != this.STOPPED){
      Display.hide();
      //останавливаем воспроизведение
      Player.stop();

      //Пробуем рестартануть 3 раза для стандартных ошибок коннекта
      if (err >= 0 && err <= 4 && this.cntErr < 3){
         //Увеличиваем счетчик ошибок
         this.cntErr++;
         this.playTimeout_id = setTimeout("Player.playVideo();", 1000);
         //отменяем счетчик скрытия инфо, если был запущен (если в режиме проигрывания)
         if (document.getElementById("back_rss").style.display=="none"){
            clearTimeout(this.sizeTimeout_id);
            Display.showSize(this.cntErr.toString() + "-reconnect");
            this.sizeTimeout_id = setTimeout("Display.hideSize();", 3000);
         }
      }else{
         //сбрасываем счетчик ошибок
         this.cntErr = 0;
         Mode="PLAYER"; //чтоб не залипал выход
         
         //выводим ошибку
         Helpbar.show();
         Helpbar.make(5);
         document.getElementById("back_rss").style.display="none";
         if (err==0)
             widgetAPI.putInnerHTML(document.getElementById('alert'), AddSpaces(7)+Player.msg_0+AddSpaces(7));
         else if (err==1)
             widgetAPI.putInnerHTML(document.getElementById('alert'), AddSpaces(7)+Player.msg_1+AddSpaces(7));
         else if (err==2)
             widgetAPI.putInnerHTML(document.getElementById('alert'), AddSpaces(7)+Player.msg_2+AddSpaces(7));
         else if (err==3)
             widgetAPI.putInnerHTML(document.getElementById('alert'), AddSpaces(7)+Player.msg_3+AddSpaces(7));
         else if (err==4)
             widgetAPI.putInnerHTML(document.getElementById('alert'), AddSpaces(7)+Player.msg_4+AddSpaces(7));
         else if (err==5)
             widgetAPI.putInnerHTML(document.getElementById('alert'), AddSpaces(7)+Player.msg_5+AddSpaces(7));
         else
             widgetAPI.putInnerHTML(document.getElementById('alert'), AddSpaces(7)+"Error playing stream #"+err+ AddSpaces(7));
         document.getElementById("alert").style.display="block";
         
         if (this.time>0)
         {
             var setupArray= new Array();
             setupArray[0]=this.url;
             setupArray[1]=this.time;
             File.saveArray(FILE_SETUP,setupArray);
         }
         setTimeout("Player.hideAlert();", 5000);    
      }
   }
}

Player.SEFPlay = function (sUrl, nTime){
    this.SefPlugin.Open('Player', '1.000', 'Player');
    this.SefPlugin.Execute('InitPlayer', sUrl);
    this.SefPlugin.OnEvent = 'Player.SefOnEvent';
    this.SefPlugin.Execute('StartPlayback', nTime);
}

Player.SefOnEvent = function (nEv, sPar1, sPar2) {
var EvTypes = 
{
    CONNECTION_FAILED: 1,
    AUTHENTICATION_FAILED: 2,
    STREAM_NOT_FOUND: 3,
    NETWORK_DISCONNECTED: 4,
    NETWORK_SLOW: 5,
    RENDER_ERROR: 6,
    RENDERING_START: 7,
    RENDERING_COMPLETE: 8,
    STREAM_INFO_READY: 9,
    DECODING_COMPLETE: 10,
    BUFFERING_START: 11,
    BUFFERING_COMPLETE: 12,
    BUFFERING_PROGRESS: 13,
    CURRENT_DISPLAY_TIME: 14,
    AD_START: 15,
    AD_END: 16,
    RESOLUTION_CHANGED: 17,
    BITRATE_CHANGED: 18,
    SUBTITLE: 19,
    CUSTOM: 20
}

    //??? Mode="PLAYER"; //чтоб не залипал выход
    switch (nEv) {
    case EvTypes.CONNECTION_FAILED:
        Player.onNetworkDisconnected();
        break;
    case EvTypes.STREAM_NOT_FOUND:
        Player.onStreamNotFound();
        break;
    case EvTypes.NETWORK_DISCONNECTED:
        Player.onNetworkDisconnected();
        break;
    case EvTypes.RENDER_ERROR:
        Player.onRenderError(sPar1);
        break;
    case EvTypes.RENDERING_COMPLETE: 
        Player.onRenderingComplete();
        break;
    case EvTypes.STREAM_INFO_READY:
        Player.onStreamInfoReady();
        break;
    case EvTypes.BUFFERING_START:
        Player.onBufferingStart();
        break;
    case EvTypes.BUFFERING_PROGRESS:
        Player.onBufferingProgress(sPar1);
        break;
    case EvTypes.BUFFERING_COMPLETE:
        Player.onBufferingComplete();
        break;
    case EvTypes.CURRENT_DISPLAY_TIME:
        Player.setCurTime(sPar1);
        break;
    }
}

Player.deinit = function()
{
   var wPlugin = document.getElementById("pluginWindow");
   if (wPlugin && (this.originalSource != null) )
   {
      wPlugin.SetSource(this.originalSource);
      alert("Restore source to " + this.originalSource);
   }
}

Player.setVideoURL = function(url) 
{ 
    this.url = url; alert("PLAYER URL = " + this.url); 
    var setupArray= new Array();
    File.loadArray(FILE_SETUP,setupArray);
    alert("setupArray[0]:"+setupArray[0]);
    alert("setupArray[1]:"+setupArray[1]);
    if (setupArray[0]==url)
       this.setup_time=setupArray[1];
    else
       this.setup_time=0;
}

Player.stop = function()
{
    if (this.state != this.STOPPED)
    {
        this.state = this.STOPPED;
        if (this.plugin){
           this.plugin.Stop();
           this.plugin.ClearScreen();
        }else if (this.SefPlugin){
           this.SefPlugin.Execute('Stop');
           this.SefPlugin.Execute('ClearScreen');
           this.SefPlugin.Close();
        }
        alert("Stopped");
    }
}

Player.stopVideo = function()
{
    //отменяем скрытие и перезапуск видео по ошибке
    clearTimeout(this.infoTimeout_id);
    clearTimeout(this.playTimeout_id);

    Player.stop();
    pluginAPI.setOnScreenSaver();
    pluginAPI.SetBannerState(0);     

    Mode=""; //"PLAYER"
    Loading.hide();
    Display.hide();
    Helpbar.show();
    Helpbar.make(0);

    document.getElementById("alert").style.display="none";
    document.getElementById("back_rss").style.display="block";
    
    var setupArray= new Array();
    setupArray[0]=this.url;
    setupArray[1]=this.time;
    File.saveArray(FILE_SETUP,setupArray);

    //сбрасываем счетчик ошибок
    this.cntErr = 0;
}
    
Player.playVideo = function(size) 
{ 
   Mode="PLAYER"; //чтоб не залипал выход
   if (this.url == null) 
       alert("No videos to play");
   else{ 
      document.getElementById("back_rss").style.display="none";
      
      size = parseInt(size);
      if(isNaN(size)) size = 0;  
      if (size <0 || size >8) size = 0;  
      this.size = size;
      this.state = this.PLAYING; 

      if (this.plugin){
         this.plugin.InitPlayer(this.url);
         this.plugin.StartPlayback(); //this.plugin.Play(this.url); 
      }else if (this.SefPlugin){
         this.SEFPlay(this.url,0);
      }
      
      pluginAPI.setOffScreenSaver(); 
      pluginAPI.SetBannerState(2); 
   } 
}
    

Player.pauseVideo = function()
{
   if (this.state != this.STOPPED)
   {
       this.state = this.PAUSED;
       if (this.plugin){
          this.plugin.Pause();
       }else if (this.SefPlugin){
          this.SefPlugin.Execute('Pause');
       }
       pluginAPI.setOnScreenSaver();
       Loading.hide();
   }
}

Player.setSpeed=function(s)
{
   this.plugin.SetPlaybackSpeed(s);
}

Player.resumeVideo = function()
{
    if (this.state != this.STOPPED)
    {
        this.state = this.PLAYING;
        
        //делаем перемотку назад на 1 сек, потому как после длительной паузы теряется коннект
        Player.skipBackwardVideo(1);

        if (this.plugin){
           this.plugin.Resume();
        }else if (this.SefPlugin){
           this.SefPlugin.Execute('Resume');
        }
        pluginAPI.setOffScreenSaver();
   }
}

Player.skipForwardVideo = function(nVal)
{
   if (this.state != this.STOPPED)
   {
       Loading.setPercent(-1);
       Loading.show();
       if (this.plugin){
          this.plugin.JumpForward(nVal);
       }else if (this.SefPlugin){
          this.SefPlugin.Execute('JumpForward', nVal);
       }
       Loading.hide();
   }
}

Player.skipBackwardVideo = function(nVal)
{
   if (this.state != this.STOPPED)
   {
      Loading.setPercent(-1);
      Loading.show();
      if (this.plugin){
         this.plugin.JumpBackward(nVal);
      }else if (this.SefPlugin){
         this.SefPlugin.Execute('JumpBackward', nVal);
      }
      Loading.hide();
   }
}

Player.JumpSetupPercent = function(prc) 
{
   if (this.state != this.STOPPED)
   {
       var jump_to_pos = (Display.totalTime/100*prc - this.time)/1000;
       if (jump_to_pos > 0)
           Player.skipForwardVideo(jump_to_pos);
       else if (jump_to_pos < 0)
           Player.skipBackwardVideo(jump_to_pos*-1)
   }
}

Player.jumpSetupTime = function()
{
   if (this.state == this.PLAYING)
   {
       if (this.setup_time>this.time)
       {
           alert("jump; "+(this.setup_time-this.time)/1000)
           if (this.plugin){
              this.plugin.JumpForward((this.setup_time-this.time)/1000);
           }else if (this.SefPlugin){
              this.SefPlugin.Execute('JumpForward', (this.setup_time-this.time)/1000);
           }
       }
   }
}


Player.getState = function()
{
    return this.state;
}

Player.setBuffer = function(len)
{
   if (this.plugin){
      this.plugin.SetTotalBufferSize(len);
   }else if (this.SefPlugin){
      this.SefPlugin.Execute('SetTotalBufferSize', len);
   }
   alert("BUFFER: "+len);
}
    
    
Player.setSize=function(mode)
{
   var dx, dy, dw, dh, cx, cy, cw, ch, s;
   if (this.state == this.PLAYING)
   {
       this.size=mode;
       var w=this.w;
       var h=this.h;

       dx=0; dy=0; dw=960; dh=540;
       cx=0; cy=0; cw=w; ch=h;           
       if (h==0){h=1;} //деление на 0
       
       switch(mode){
        case 0:
            if (w/h < 1.79){
                s = '16x9 FULL';
            }else{
                s = 'ORIGINAL';
                dh = 960*h/w;
                dy = (540-dh)/2;
            }
            break;
        case 1:
            if (w == 0){
                s = 'w/h=1.67';
                dx = 30;
                dw = 900;
            }else{
                s = '14x9';
                cy = 0.0625*h;
                cw = w;
                ch = 0.875*h;
            }
            break;
        case 2:
            if (w/h >= 1.35 || w == 0){
                s = 'w/h=1.56';
                dx = 60;
                dw = 840;
            }else{
                s = '4x3 ZOOM 2';
                cy = 0.115*h;
                cw = w;
                ch = 0.77*h;
            }
            break;
        case 3:
            if (w/h >= 1.35 || w == 0){
                s = 'w/h=1.45';
                dx = 90;
                dw = 780;
            }else{
                s = '4x3 ZOOM 1';
                dx = 60;
                dw = 840;
                cy = 0.0625*h;
                cw = w;
                ch = 0.875*h;
            }
            break;
        case 4:
            s = '4x3';
            dx = 120;
            dw = 720;
            break;
        case 5:
            if (w/h >= 1.79){
                s = 'ORIGINAL ZOOM 1';
                dh = 960*h/(w*0.85);
                dy = (540-dh)/2;
                cx = 0.075*w;
                cw = 0.85*w;
            }else{
                s = '16x9 ZOOM 1';
                cx = 0.0625*w;
                cy = 0.0625*h;
                cw = 0.875*w;
                ch = 0.875*h;
            }
            break;
        case 6:
            if (w/h >= 1.79){
                s = 'ORIGINAL ZOOM 2';
                dh = 960*h/(w*0.75);
                dy = (540-dh)/2;
                cx = 0.125*w;
                cw = 0.75*w;
            } else {
                s = '16x9 ZOOM 2';
                cx = 0.125*w;
                cy = 0.125*h;
                cw = 0.75*w;
                ch = 0.75*h;
            }
            break;
        case 7:
            if (w>0 && w<=dw && h<=dh){
                s = "Default Size";
                dx = (960-w)/2; 
                dy = (540-h)/2; 
                dw = w; 
                dh = h;
            }else{
              	s = 'Fit to window';
            }
            break;
        case 8:
            s = 'Fit to window FULL';
            break;
        default:
            s = "Unknown";
            break;
       }
       
       if (this.SefPlugin){
          this.SefPlugin.Execute("SetDisplayArea",dx,dy,dw,dh);
	      this.SefPlugin.Execute("SetCropArea",cx,cy,cw,ch);
       }else{
          this.plugin.SetDisplayArea(dx,dy,dw,dh);
          this.plugin.SetCropArea(cx,cy,cw,ch);
       }

       s = s+'<br/>('+this.w+'x'+this.h+')';
       Display.showSize(s);
       setTimeout("Display.hideSize();", 3000);
   }
}

Player.getSize=function(){
   return this.size;
}

function DelSpaces(str){
    if (str.toString()!=''){
       str = str.replace(/\s/g, '');
    }
    return str.toString();
}

function AddSpaces(nVal){
var str = "";

    for (var i = 0; i < nVal; i++){
       str = str + "&#160;";
    }

    return str;
}
